@if not exist echo echo off
rem usage: PWAVRLD project [-lpt N]

if not X%1 == X goto parm_ok1
echo please supply project file name as first parameter!
echo usage: PWAVRLD project [-lpt N]
goto abort
:parm_ok1

if exist %1.rom goto parm_ok2
echo can't find PicoWeb ROM file %1.rom!
goto abort
:parm_ok2

if exist %PWDEV%\bin\avr.exe goto got_avr
echo Can't find program %PWDEV%\bin\avr.exe!
goto abort
:got_avr

if not exist %1.rom goto abort
echo Loading PicoWeb program memory with '%1.rom'
if "%remote%" == "" goto load_local

copy %1.rom %remote%
set eeload=
if not exist %1.ep goto no_ep_remote
copy %1.ep %remote%
set eeload=-le %1.ep

:no_ep_remote
echo.avr -ce -lp %1.rom %eeload% -en >%remote%\work.bat
:wait
if not exist %remote%\work.bat goto load_complete
perl -e "sleep 2"
goto wait

:load_local
echo %PWDEV%\bin\avr %2 %3 %4 -ce -lp %1.rom %2 %3 %4
%PWDEV%\bin\avr %2 %3 %4 -ce -lp %1.rom %2 %3 %4
if errorlevel 1 goto abort

if not exist %1.ep goto no_ep
echo Loading PicoWeb EEPROM memory with '%1.ep'
echo %PWDEV%\bin\avr %2 %3 %4 -le %1.ep
%PWDEV%\bin\avr %2 %3 %4 -le %1.ep
if errorlevel 1 goto abort
:no_ep

echo Enabling PicoWeb server'
echo %PWDEV%\bin\avr %2 %3 %4 -en
%PWDEV%\bin\avr %2 %3 %4 -en
if errorlevel 1 goto abort

:load_complete
echo PicoWeb AVR firmware load complete.
goto done

:abort
echo Aborted PicoWeb AVR firmware load!
:done
