@if not exist echo echo off
rem usage: PWBUILD project [clean]

if not X%1 == X goto parm_ok1
echo please supply project file name as first parameter!
echo usage: PWBUILD project [clean]
goto oops
:parm_ok1

if X%2 == Xclean goto clean

if exist %1.pwp goto parm_ok2
echo can't find project file %1.pwp!
goto oops
:parm_ok2

:clean
echo Deleting output files
if exist %1.i del %1.i
if exist %1.pi del %1.pi
if exist %1.esi del %1.esi
if exist %1.el del %1.el
if exist %1.ep del %1.ep
if exist %1.lst del %1.lst
if exist %1.eep del %1.eep
if exist %1.obj del %1.obj
if exist %1.rom del %1.rom
if exist %1.err del %1.err
if exist %1.imp del %1.imp
if exist %1.dat del %1.dat
if exist %1.asi del %1.asi

if exist cmd.inc del cmd.inc
if exist ip.inc del ip.inc
if exist ether.inc del ether.inc
if exist userdef.h del userdef.h
if exist userasm.asm del userasm.asm
if exist userrst.asm del userrst.asm
if exist usersid.asm del usersid.asm
if exist userfid.asm del userfid.asm
if exist img.tmp del img.tmp

if X%2 == Xclean goto done

echo.Making command table.
if not exist cmd.txt goto no_cmd_txt
%PWDEV%\bin\perl %PWDEV%\bin\cmd2asm.pl cmd.txt >cmd.inc
goto cmd_txt
:no_cmd_txt
%PWDEV%\bin\perl %PWDEV%\bin\cmd2asm.pl %PWDEV%\lib\cmd.txt >cmd.inc
:cmd_txt
if errorlevel 1 goto oops

echo.Setting IP address
if exist ip goto ip_ok
echo can't find IP address definition file 'ip'!
goto oops
:ip_ok
%PWDEV%\bin\perl %PWDEV%\bin\ip2hex.pl -v - <ip >ip.inc
if errorlevel 1 goto oops

echo.Setting Ethernet address
if exist ether goto mac_ok
echo can't find Ethernet address definition file 'ether'!
goto oops
:mac_ok
%PWDEV%\bin\perl %PWDEV%\bin\mac2hex.pl -v - <ether >ether.inc
if errorlevel 1 goto oops

echo.Processing HTML/images/CGI.
%PWDEV%\bin\perl %PWDEV%\bin\pwproj.pl -v %PWDEV%\lib\picbin.inc %1.pwp %1.dat userdef.h user
if errorlevel 1 goto oops
echo #define PW_STRINGS "%1.asi" >>userdef.h

echo.Preprocessing.
%PWDEV%\bin\cpp -I- -I. -I%PWDEV%\lib  -w -i %PWDEV%\lib\picweb.asm -o %1.i
if errorlevel 1 goto oops

%PWDEV%\bin\grep ";_;_import" %PWDEV%\lib\picbin.inc | %PWDEV%\bin\perl %PWDEV%\bin\getimp.pl >%1.imp
if errorlevel 1 goto oops
if not exist %PWDEV%\lib\picbin.inc goto oops

%PWDEV%\bin\perl %PWDEV%\bin\ppre.pl %1.i %1.pi %1.asi %1.imp
if errorlevel 1 goto oops
if not exist %1.i goto oops

echo.Assembling.
%PWDEV%\bin\perl %PWDEV%\bin\avrerr.pl %1.pi %1.lst %1.rom
if errorlevel 1 goto oops
if exist %1.obj del %1.obj

if not exist %1.eep goto no_eep
echo.Cracking %1.eep into %1.ep and %1.el
%PWDEV%\bin\perl %PWDEV%\bin\cgisplit.pl %1 b000
if errorlevel 1 goto oops
:no_eep

if exist %1.obj del %1.obj
if exist img.tmp del img.tmp
goto done

:oops
echo Aborted!
goto finis

:done
echo.Done.
:finis
