;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, and Bruce D. Lightner.
; Use subject to licensing restrictions described in "PICOWEB SERVER
; SOFTWARE LICENSE AGREEMENT DATED JULY 14, 1999" (See file LICENSE.txt).
;-------------------------------------------------------------------------

#if !defined(TCPIP_INC_INCLUDED)
#define TCPIP_INC_INCLUDED
#define _FIN     0x0001
#define _SYN     0x0002
#define _RST     0x0004
#define _PUSH    0x0008
#define _ACK     0x0010
#define _DO_B(x)  (((x/4)+5)<<12)
#define _DO      _DO_B(0)

#define ETH_DEST 0
#define ETH_SRC ETH_DEST+6
#define ETH_PT ETH_SRC+6
#define IPH  ETH_PT+2
#define IP_HVTOS   IPH+0
#define IP_LEN     IPH+2
#define IP_ID      IPH+4
#define IP_FFO     IPH+6
#define IP_TTLP    IPH+8
#define IP_CHKSUM  IPH+10
#define IP_SRCADDR IPH+12
#define IP_DSTADDR IPH+16
#define IP_HEADER_LEN  20
#define IPD IPH+IP_HEADER_LEN

#define TCP_HEADER  IPD+0
#define TCP_SP      IPD+0
#define TCP_DP      IPD+2
#define TCP_SEQ     IPD+4
#define TCP_ACK     IPD+8
#define TCP_FLAGS   IPD+12
#define TCP_WIN     IPD+14
#define TCP_CHKSUM  IPD+16
#define TCP_URG     IPD+18
#define TCP_DATA    IPD+20
#define TCP_HEADER_LEN  20

#define UDP_HEADER  IPD+0
#define UDP_SP          UDP_HEADER+0
#define UDP_DP          UDP_HEADER+2
#define UDP_LEN         UDP_HEADER+4
#define UDP_CHKSUM      UDP_HEADER+6
#define UDP_DATA        UDP_HEADER+8
#define UDP_HEADER_LEN 8

#define SET_ADDL(val)      \
    .dw pmovwi,buf+4,byte4(val)|(byte3(val)<<8),pmovwi,buf+6,byte2(val)|(low(val)<<8)
#define R2X_ADDL(to,from)   \
    .dw pr2s,buf,from,4,paddn,buf,buf+4,4,ps2x,to,buf,4
#define R2X_LONG(to,from)  .dw pr2x,to,from,4
#define R2X_WORD(to,from)  .dw pr2x,to,from,2
#define	SET_IP(i,l,a,b,c,d)  .dw i,l,a|(b<<8),i,l+2,c|(d<<8)

#define BSWAP(v)  ((low(v)<<8)|high(v))

#endif



