//-------------------------------------------------------------------------
// Copyright (c) 1999 Steven Freyder, David Helland, Bruce D. Lightner and
// Lightner Engineering.  Use subject to licensing restrictions described
// the file LICENSE.txt.  If you do not agree with the licensing terms then
// you must return and/or destroy this software immediately!
//-------------------------------------------------------------------------

/* userdef.h - User-supplied application-specific build definitions. */

/*
 * bootup banner sent to serial port
 */
#define BANNER "\r\nMy PicoWeb Application\r\n"

/*
 * user-supplied application specific source code files
 */
//#define USER_RESET_ASM "???"
//#define USER_SLOW_IDLE_ASM "???"
//#define USER_FAST_IDLE_ASM "???"
//#define USER_ASM "???"

/*
 * "where to get my IP address from" section.  only define
 * one of the following symbols:
 */
#define EEPROM_IP                /* use file "ip" for IP address */
//#define SEEPROM_IP (0x4000-4)  /* where SEEPROM has IP address */
//#define BOOTP                  /* not implemented! */

/*
 * use AVR hardware watchdog timer
 */
#define ENABLE_WATCHDOG

/*
 * define the DEBUGGER symbol if you want a command line interpreter,
 * AKA debugger.  it costs memory, and uses the serial port, so you
 * have been forewarned!
 */
#define DEBUGGER

/*
 * set serial port baud rate
 */
#define SERIAL_BAUD_DIVISOR 25    /* 19200 @ 8 MHz */
