;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, Bruce D. Lightner and
; Lightner Engineering.  Use subject to licensing restrictions described
; the file LICENSE.txt.  If you do not agree with the licensing terms then
; you must return and/or destroy this software immediately!
;-------------------------------------------------------------------------

;+
; **-tcp_recv-user TCP receive handler.
;
; inputs:
;   packet in receive buffer
;   putchar output redirected to network
;
; outputs:
;   packet written to transmit buffer using pputc/equivalent
;   must return with RET.
;-

import_tcp_recv:
tcp_recv:
    rcall pcode
    pcall tcp_recv_1
    asm
    ret
tcp_recv_1:
    pr2s buf,TCP_DP,2                ; get destination port
#if defined(DEBUGGER)
    pcmpwi buf,BSWAP(TCPPORT_CMD)       ; check for command line port
    pjumpeq tcpget_cmdline
#endif
    pcmpwi buf,BSWAP(611)           ; check for SEEPROM loader port
    pjumpeq seeprom_loader
    pcmpwi buf,BSWAP(612)           ; check for EEPROM loader port
    pjumpeq seeprom_loader
    pcmpwi buf,BSWAP(80)            ; check for www/http
    pjumpne unknown_tcp_port        ; whoops!  unknown port
    ;
    ; build the URL content in the TCP_DATA area of the transmit buffer.
    ;
    pmovwi buf,[data_addr]
    paddwi buf,4                    ; skip over "GET "
    pr2s buf,[buf],buf_len                ; save first n bytes of request
#if defined(SHOW_HTTP_GET)
    pmovbi putc_b,0
    pprinta 0,[data_addr],30        ; show first 30 of get request
    pmovbi putc_b,1
#endif
    asm
    pushw p
    rcall process_url
    popw p
    rcall pcode
    pret
unknown_tcp_port:
    pret
;
;
; this is the external command line interface usually located on
; tcp port 911.
;
;
#if defined(DEBUGGER)
tcpget_cmdline:
    pmovwi buf,[data_addr]
    paddwi buf,5
    pr2s inbuf,[buf],max_nch                 ; copy url to command buffer
    asm
    rcall cmd_text_header
    rcall cli_exec
    rcall pcode
    pret
cmd_text_header:
    outstr cmd_text_msg
;;string cmd_text_msg "HTTP/1.0 200\nContent-type: text/html\n\n"
    ret
#endif
